/*
 * プロフィール情報の編集画面
 * 
 */

package net.karappo.android.myqr;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TableRow;

public class EditActivity extends Activity implements OnClickListener 
{
	private static final String TAG = "MyQR";
	
	// -----------------------------------------
	// Viewへの参照
	
	private EditText ET_name_last;
	private EditText ET_name_first;
	private EditText ET_sound_last;
	private EditText ET_sound_first;
	private EditText ET_tel;
	private EditText ET_tel_2;
	private EditText ET_email;
	private EditText ET_email_2;
	private EditText ET_address;
	
	private TableRow TR_tel_2;
	private TableRow TR_email_2;
	
	private ImageButton BTN_addTel;
	private ImageButton BTN_deleteTel;
	private ImageButton BTN_addEmail;
	private ImageButton BTN_deleteEmail;
	private ImageButton BTN_addAddress;
	private ImageButton BTN_deleteAddress;
	
	private Button BTN_save;
	
	// -----------------------------------------
	// 保存する情報

	// プロフィール情報
	private String name_last;
	private String name_first;
	private String sound_last;
	private String sound_first;
	private String tel;
	private String tel_2;
	private String email;
	private String email_2;
	private String address;
	
	// キャリアー
	private int carrier;
	
	// 第２の表示非表示
	private Boolean tel_2_visible = false;
	private Boolean email_2_visible = false;
	private Boolean address_visible = false;
	
	// -----------------------------------------
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		Log.d(TAG, "EditActivity onCreate");
		
		super.onCreate(savedInstanceState);
        setContentView(R.layout.edit);
        
        ET_name_last 	= (EditText) findViewById(R.id.ET_name_last);
        ET_name_first 	= (EditText) findViewById(R.id.ET_name_first);
        ET_sound_last 	= (EditText) findViewById(R.id.ET_sound_last);
        ET_sound_first 	= (EditText) findViewById(R.id.ET_sound_first);
        ET_tel 			= (EditText) findViewById(R.id.ET_tel);
        ET_tel_2 		= (EditText) findViewById(R.id.ET_tel_2);
        ET_email 		= (EditText) findViewById(R.id.ET_email);
        ET_email_2 		= (EditText) findViewById(R.id.ET_email_2);
        ET_address 		= (EditText) findViewById(R.id.ET_address);
        
        TR_tel_2 		= (TableRow) findViewById(R.id.TR_tel_2_edit);
    	TR_email_2	 	= (TableRow) findViewById(R.id.TR_email_2_edit);
    	
    	BTN_addTel 			= (ImageButton) findViewById(R.id.BTN_add_tel);
    	BTN_deleteTel 		= (ImageButton) findViewById(R.id.BTN_delete_tel);
    	BTN_addEmail 		= (ImageButton) findViewById(R.id.BTN_add_email);
    	BTN_deleteEmail 	= (ImageButton) findViewById(R.id.BTN_delete_email);
    	BTN_addAddress		= (ImageButton) findViewById(R.id.BTN_add_address);
    	BTN_deleteAddress	= (ImageButton) findViewById(R.id.BTN_delete_address);
    	
    	BTN_save			= (Button) findViewById(R.id.BTN_save);
    	
    	//
    	
    	BTN_addTel.setOnClickListener(this);
    	BTN_deleteTel.setOnClickListener(this);
    	BTN_addEmail.setOnClickListener(this);
    	BTN_deleteEmail.setOnClickListener(this);
    	BTN_addAddress.setOnClickListener(this);
    	BTN_deleteAddress.setOnClickListener(this);
    	BTN_save.setOnClickListener(this);
      	
		// データの受け取り
//    	Log.d(TAG, "start intent data load ...");
    	Intent intent 	= getIntent();
    	name_last 		= getIntent().getStringExtra(MyQRActivity.PREF_NAME_LAST);
    	name_first 		= intent.getStringExtra(MyQRActivity.PREF_NAME_FIRST);
    	sound_last 		= intent.getStringExtra(MyQRActivity.PREF_SOUND_LAST);
    	sound_first 	= intent.getStringExtra(MyQRActivity.PREF_SOUND_FIRST);
    	tel 			= intent.getStringExtra(MyQRActivity.PREF_TEL);
    	tel_2 			= intent.getStringExtra(MyQRActivity.PREF_TEL_2);
    	tel_2_visible 	= intent.getBooleanExtra(MyQRActivity.PREF_TEL_2_VISIBLE, tel_2_visible);
    	email 			= intent.getStringExtra(MyQRActivity.PREF_EMAIL);
    	email_2 		= intent.getStringExtra(MyQRActivity.PREF_EMAIL_2);
    	email_2_visible = intent.getBooleanExtra(MyQRActivity.PREF_EMAIL_2_VISIBLE, email_2_visible);
    	carrier 		= intent.getIntExtra(MyQRActivity.PREF_CARRIER,carrier);
    	address 		= intent.getStringExtra(MyQRActivity.PREF_ADDRESS);
    	address_visible = intent.getBooleanExtra(MyQRActivity.PREF_ADDRESS_VISIBLE,address_visible);
//		Log.d(TAG, "intent data loaded !");
		
		// テキストの設定
        setValOrHint(ET_name_last,		name_last,		R.string.hint_name_last);
        setValOrHint(ET_name_first,		name_first,		R.string.hint_name_first);
        setValOrHint(ET_sound_last,		sound_last,		R.string.hint_sound_last);
        setValOrHint(ET_sound_first,	sound_first,	R.string.hint_sound_first);
        setValOrHint(ET_tel,			tel,			R.string.hint_tel);
        setValOrHint(ET_tel_2,			tel_2,			R.string.hint_tel);
        setValOrHint(ET_email, 			email,			R.string.hint_mail);
        setValOrHint(ET_email_2, 		email_2,		R.string.hint_mail);
        setValOrHint(ET_address, 		address,		R.string.hint_address);
        
        // 表示／非表示のあるもの
        setTel2Visible(tel_2_visible);
        setEmail2Visible(email_2_visible);
        setAddressVisible(address_visible);
        
	}
    
	// -----------------------------------------------
	
	// tel2の表示切替
	private void setTel2Visible(Boolean visible)
	{
		if(visible) 
        {
        	TR_tel_2.setVisibility(View.VISIBLE);
        	BTN_addTel.setVisibility(View.INVISIBLE);
        }
        else
        {
        	TR_tel_2.setVisibility(View.GONE);
        	BTN_addTel.setVisibility(View.VISIBLE);
        }
	}
	
	// tel2の表示切替
	private void setEmail2Visible(Boolean visible)
	{
		if(visible) 
        {
        	TR_email_2.setVisibility(View.VISIBLE);
        	BTN_addEmail.setVisibility(View.INVISIBLE);
        }
        else
        {
        	TR_email_2.setVisibility(View.GONE);
        	BTN_addEmail.setVisibility(View.VISIBLE);
        }
	}
	
	// tel2の表示切替
	private void setAddressVisible(Boolean visible)
	{
		if(visible) 
        {
			ET_address.setVisibility(View.VISIBLE);
			BTN_addAddress.setVisibility(View.GONE);
			BTN_deleteAddress.setVisibility(View.VISIBLE);
        }
        else
        {
        	ET_address.setVisibility(View.GONE);
			BTN_addAddress.setVisibility(View.VISIBLE);
			BTN_deleteAddress.setVisibility(View.GONE);
        }
		
	}
	
	// -----------------------------------------------
	
	private void setValOrHint( EditText eText, String prof_val,  int hintString )
    {
		Log.d(TAG, ">"+eText);
		Log.d(TAG, ">"+prof_val);
		Log.d(TAG, ">"+hintString);
    	if( (prof_val == null) || (prof_val.length() == 0) )
    	{
    		Log.d(TAG, eText.toString()+"show hint text : "+ eText.getHint());
    		eText.setHint(hintString);
    	}
    	else
    	{
    		Log.d(TAG, eText.toString()+"show val : "+prof_val);
    		eText.setText(prof_val);
    	}
    }

	public void onClick(View v)
    {
    	switch(v.getId())
    	{
    	case R.id.BTN_save:
    		// Viewからデータを取得
        	name_last 	= ET_name_last.getText().toString();
        	name_first 	= ET_name_first.getText().toString();
        	sound_last 	= ET_sound_last.getText().toString();
        	sound_first = ET_sound_first.getText().toString();
        	tel 		= ET_tel.getText().toString();
        	tel_2 		= ET_tel_2.getText().toString();
        	email 		= ET_email.getText().toString();
        	email_2 	= ET_email_2.getText().toString();
        	address		= ET_address.getText().toString();
        	
        	// データを受け渡し準備
        	Intent intent = new Intent(getApplicationContext(),EditActivity.class);
    		intent.putExtra(MyQRActivity.PREF_NAME_LAST, name_last);
    		intent.putExtra(MyQRActivity.PREF_NAME_FIRST, name_first);
    		intent.putExtra(MyQRActivity.PREF_SOUND_LAST, sound_last);
    		intent.putExtra(MyQRActivity.PREF_SOUND_FIRST, sound_first);
    		intent.putExtra(MyQRActivity.PREF_TEL, tel);
    		intent.putExtra(MyQRActivity.PREF_TEL_2, tel_2);
    		intent.putExtra(MyQRActivity.PREF_TEL_2_VISIBLE, tel_2_visible);
    		intent.putExtra(MyQRActivity.PREF_EMAIL, email);
    		intent.putExtra(MyQRActivity.PREF_EMAIL_2, email_2);
    		intent.putExtra(MyQRActivity.PREF_EMAIL_2_VISIBLE, email_2_visible);
    		intent.putExtra(MyQRActivity.PREF_ADDRESS, address);
    		intent.putExtra(MyQRActivity.PREF_ADDRESS_VISIBLE, address_visible);
    		intent.putExtra(MyQRActivity.PREF_CARRIER, carrier);
    		setResult(RESULT_OK, intent);
    		
        	// 閉じる
        	finish();
        	break;
        	
    	case R.id.BTN_add_tel:
    		tel_2_visible = true;
    		setTel2Visible(tel_2_visible);
    		ET_tel_2.requestFocus();
            break;
            
    	case R.id.BTN_delete_tel:
    		tel_2_visible = false;
    		setTel2Visible(tel_2_visible);
    		ET_tel.requestFocus();
            break;
            
    	case R.id.BTN_add_email:
    		email_2_visible = true;
    		setEmail2Visible(email_2_visible);
    		ET_email_2.requestFocus();
            break;
            
    	case R.id.BTN_delete_email:
    		email_2_visible = false;
    		setEmail2Visible(email_2_visible);
    		ET_email.requestFocus();
            break;
        
    	case R.id.BTN_add_address:
    		address_visible = true;
    		setAddressVisible(address_visible);
    		ET_address.requestFocus();
            break;
            
    	case R.id.BTN_delete_address:
    		address_visible = false;
    		setAddressVisible(address_visible);
    		if(email_2_visible) ET_email_2.requestFocus();
    		else ET_email.requestFocus();
            break;
            
    	default :
    		break;
    	}
    	
    }
	
	
}